package exnihilocreatio.blocks;

import exnihilocreatio.ExNihiloCreatio;
import exnihilocreatio.registries.CrucibleRegistryStone;
import exnihilocreatio.tiles.TileCrucibleWood;
import exnihilocreatio.util.IHasModel;
import mcjty.theoneprobe.api.IProbeHitData;
import mcjty.theoneprobe.api.IProbeInfo;
import mcjty.theoneprobe.api.IProbeInfoAccessor;
import mcjty.theoneprobe.api.ProbeMode;
import net.minecraft.block.ITileEntityProvider;
import net.minecraft.block.material.Material;
import net.minecraft.block.state.IBlockState;
import net.minecraft.entity.player.EntityPlayer;
import net.minecraft.item.ItemStack;
import net.minecraft.tileentity.TileEntity;
import net.minecraft.util.EnumFacing;
import net.minecraft.util.EnumHand;
import net.minecraft.util.math.BlockPos;
import net.minecraft.world.World;
import net.minecraftforge.fluids.FluidStack;
import net.minecraftforge.fluids.capability.CapabilityFluidHandler;
import net.minecraftforge.fluids.capability.IFluidHandler;

import javax.annotation.Nonnull;
import javax.annotation.Nullable;

public class BlockCrucibleWood extends BlockBase implements IProbeInfoAccessor, IHasModel, ITileEntityProvider {

    public BlockCrucibleWood() {
        super(Material.field_151575_d, "block_crucible_wood");

        func_149647_a(ExNihiloCreatio.tabExNihilo);

        this.func_149711_c(2.0f);
    }

    @Override
    public boolean func_180639_a(World world, BlockPos pos, IBlockState state, EntityPlayer player, EnumHand hand, EnumFacing side, float hitX, float hitY, float hitZ) {
        if (world.field_72995_K)
            return true;

        TileCrucibleWood te = (TileCrucibleWood) world.func_175625_s(pos);

        if (te != null) {
            IFluidHandler fluidHandler = te.getCapability(CapabilityFluidHandler.FLUID_HANDLER_CAPABILITY, side);
            return te.onBlockActivated(world, pos, state, player, hand, side, hitX, hitY, hitZ, fluidHandler);
        } else {
            return true;
        }
    }


    @Override
    @Deprecated
    public boolean func_149730_j(IBlockState state) {
        return false;
    }

    @Override
    @Deprecated
    public boolean func_149662_c(IBlockState state) {
        return false;
    }

    @Override
    @Deprecated
    public boolean func_149686_d(IBlockState state) {
        return false;
    }

    @Override
    public void addProbeInfo(ProbeMode mode, IProbeInfo probeInfo, EntityPlayer player, World world,
                             IBlockState blockState, IProbeHitData data) {
        TileCrucibleWood crucible = (TileCrucibleWood) world.func_175625_s(data.getPos());

        if (crucible == null)
            return;

        ItemStack solid = crucible.getCurrentItem() == null ? null : crucible.getCurrentItem().getItemStack();
        FluidStack liquid = crucible.getTank().getFluid();

        String solidName = solid == null ? "None" : solid.func_82833_r();
        String liquidName = liquid == null ? "None" : liquid.getLocalizedName();

        int solidAmount = Math.max(0, crucible.getSolidAmount());

        ItemStack toMelt = crucible.getItemHandler().getStackInSlot(0);

        if (!toMelt.func_190926_b()) {
            solidAmount += CrucibleRegistryStone.getMeltable(toMelt).getAmount() * toMelt.func_190916_E();
        }

        probeInfo.text(String.format("Solid (%s): %d", solidName, solidAmount));
        probeInfo.text(String.format("Liquid (%s): %d", liquidName, crucible.getTank().getFluidAmount()));
        probeInfo.text("Rate: " + crucible.getHeatRate() + "x");
    }

    @Nullable
    @Override
    public TileEntity func_149915_a(@Nonnull World worldIn, int meta) {
        return new TileCrucibleWood();
    }
}
